
Efl_Object *_efl_generic_model_efl_object_constructor(Eo *obj, Efl_Generic_Model_Data *pd);


void _efl_generic_model_efl_object_destructor(Eo *obj, Efl_Generic_Model_Data *pd);


Eina_Iterator *_efl_generic_model_efl_model_properties_get(const Eo *obj, Efl_Generic_Model_Data *pd);


Eina_Future *_efl_generic_model_efl_model_property_set(Eo *obj, Efl_Generic_Model_Data *pd, const char *property, Eina_Value *value);


Eina_Value *_efl_generic_model_efl_model_property_get(const Eo *obj, Efl_Generic_Model_Data *pd, const char *property);


Efl_Object *_efl_generic_model_efl_model_child_add(Eo *obj, Efl_Generic_Model_Data *pd);


void _efl_generic_model_efl_model_child_del(Eo *obj, Efl_Generic_Model_Data *pd, Efl_Object *child);


Eina_Future *_efl_generic_model_efl_model_children_slice_get(Eo *obj, Efl_Generic_Model_Data *pd, unsigned int start, unsigned int count);


unsigned int _efl_generic_model_efl_model_children_count_get(const Eo *obj, Efl_Generic_Model_Data *pd);


static Eina_Bool
_efl_generic_model_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_GENERIC_MODEL_EXTRA_OPS
#define EFL_GENERIC_MODEL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_generic_model_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_generic_model_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, _efl_generic_model_efl_model_properties_get),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, _efl_generic_model_efl_model_property_set),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, _efl_generic_model_efl_model_property_get),
      EFL_OBJECT_OP_FUNC(efl_model_child_add, _efl_generic_model_efl_model_child_add),
      EFL_OBJECT_OP_FUNC(efl_model_child_del, _efl_generic_model_efl_model_child_del),
      EFL_OBJECT_OP_FUNC(efl_model_children_slice_get, _efl_generic_model_efl_model_children_slice_get),
      EFL_OBJECT_OP_FUNC(efl_model_children_count_get, _efl_generic_model_efl_model_children_count_get),
      EFL_GENERIC_MODEL_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_generic_model_class_desc = {
   EO_VERSION,
   "Efl.Generic_Model",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Generic_Model_Data),
   _efl_generic_model_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_generic_model_class_get, &_efl_generic_model_class_desc, EFL_LOOP_MODEL_CLASS, NULL);
